<template>
  <div class="q-pa-md">
    <q-table title="Store" :rows="pios" row-key="id" :columns="columns">
      <template v-slot:body-cell-action="data">
        <q-td :data="data" align="center">
          <q-btn
            color="primary"
            icon="swap_vert"
            @click="Static(data.row)"
            size="sm"
            danse
            class="q-ml-sm"
          />
          <q-btn
            color="primary"
            icon="edit"
            @click="edit(data.row)"
            size="sm"
            danse
            class="q-ml-sm"
          />
        </q-td>
      </template>
      <template v-slot:top>
        <div class="row" style="width: 100%; margin: 5px;">
          <q-space />
          <q-select
            filled
            v-model="store_id"
            use-input
            dense
            input-debounce="0"
            label="Store"
            :options="optionsStore"
            @filter="filterStore"
            @new-value="createValue"
            @keyup.enter="categorys"
          >
            <template v-slot:no-option>
              <q-item>
                <q-item-section class="text-grey">
                  No results
                </q-item-section>
              </q-item>
            </template>
          </q-select>
          <q-space />
          <q-select
            filled
            v-model="AddData.product_id"
            use-input
            dense
            input-debounce="0"
            label="Category"
            :options="optionsCategory"
            @filter="filterCategory"
            @keyup.enter="pio"
          >
            <template v-slot:no-option>
              <q-item>
                <q-item-section class="text-grey">
                  No results
                </q-item-section>
              </q-item>
            </template>
          </q-select>
          <q-space />
          <q-input
            dense
            rounded
            standout="bg-info text-white"
            v-model="text"
            input-class="text-right"
            class=""
          >
            <template v-slot:append>
              <q-icon v-if="text === ''" name="search" />
              <q-icon
                v-else
                name="clear"
                class="cursor-pointer"
                @click="text = ''"
              />
            </template>
          </q-input>
          <q-space />
        </div>
        <div class="row" style="width: 100%;">
          <q-space />
          <q-btn
            color="primary"
            :disable="loading"
            label="Input product"
            @click="ShowAddModal()"
          />
          <q-space />
          <q-btn
            color="primary"
            :disable="loading"
            label="Output product"
            @click="openStoreModal(-1)"
          />
          <q-space />
          <q-btn
            color="primary"
            :disable="loading"
            label="Move product"
            @click="openStoreModal(-1)"
          />
          <q-space />
        </div>
      </template>
    </q-table>
    <!-- Add Model -->
    <q-dialog v-model="AddModal" persistent>
      <q-card
        style="min-width: 350px;"
        @keyup.enter="SendAddData"
        @keyup.esc="AddModalCancel()"
      >
        <q-card-section>
          <div class="text-h6">New Input Product</div>
        </q-card-section>

        <q-card-section class="q-pt-none">
          <div class="text-h7">Product</div>
          <q-select
            filled
            v-model="AddData.product_id"
            use-input
            input-debounce="0"
            label="Products"
            :options="optionsProduct"
            @filter="filterProduct"
          >
            <template v-slot:no-option>
              <q-item>
                <q-item-section class="text-grey">
                  No results
                </q-item-section>
              </q-item>
            </template>
          </q-select>
          <div class="text-h7">Store</div>

          <div class="text-h7">Count</div>

          <q-input v-model.number="AddData.count" type="number" filled />

          <div class="text-h7">Pirce</div>

          <q-input v-model.number="AddData.price" type="number" filled />
        </q-card-section>
        <q-card-actions align="right" class="text-primary">
          <q-btn flat label="Create" @click="SendAddData" />
          <q-btn flat label="Cancel" @click="AddModalCancel()" />
        </q-card-actions>
      </q-card>
    </q-dialog>
    <!--end Add model-->
    <!-- Hisob kitob-->
    <q-dialog v-model="StaticModel" persistent style="width: 100%;">
      <q-layout
        view="lHh lpr lFf"
        container
        style="width: 100%;"
        class="shadow-2 rounded-borders"
      >
        <q-header elevated>
          <q-bar>
            <q-icon name="laptop_chromebook" />
            <div>Google Chrome</div>

            <q-space />

            <q-btn dense flat icon="minimize" />
            <q-btn dense flat icon="crop_square" />
            <q-btn dense flat icon="close" />
          </q-bar>
        </q-header>

        <q-page-container></q-page-container>
      </q-layout>
    </q-dialog>
  </div>
</template>
<script>
import axios from 'axios'
import { date } from 'quasar'
export default {
  name: 'PageIndex',
  data() {
    return {
      pios: [
        {
          id: 1,
        },
      ],
      product: [],
      store: [],
      store_id: null,
      category: [],
      optionsStore: null,
      optionsProduct: null,
      optionsCategory: null,
      AddData: {
        id: '',
        product_id: '',
        user_id: '',
        store_id: '',
        count: '',
        price: '',
      },
      text: '',
      AddModal: false,
      StaticModel: false,
      columns: [
        {
          name: 'index',
          field: 'id',
          label: '#',
          align: 'left',
          sortable: true,
        },
        {
          name: 'name',
          field: 'name',
          label: 'Name',
          align: 'left',
          sortable: true,
        },
        {
          name: 'Count',
          field: 'count',
          label: 'Count',
          align: 'left',
          sortable: true,
        },
        {
          name: 'price',
          field: 'price',
          label: 'Price',
          align: 'left',
          sortable: true,
        },
        {
          name: 'action',
          label: 'Action',
          align: 'center',
          style: 'width: 20px !important',
        },
      ],
    }
  },
  async mounted() {
    this.products()
    this.stores()
  },
  methods: {
    auth() {
      this.$e('You are not authorized')
      this.$q.loading.hide()
      this.$router
        .push('/login')
        .then((s) => {})
        .catch((e) => {})
    },
    async products() {
      await axios
        .get('http://127.0.0.1:8000/api/statistic/get')
        .then((response) => {
          var data = response.data
          for (var i = 0; i < data.length; i++) {
            this.product.push(data[i].name)
          }
          if (response.data != null) {
            this.$q.loading.hide()
          }
        })
        .catch((e) => {
          var res = e.response
          this.$q.loading.hide()
          if (res.status == 401) {
            this.auth()
          } else {
            this.$e('Something Errors')
          }
        })
    },
    async categorys() {
      var a = []

      await axios
        .get(
          'http://127.0.0.1:8000/api/statistic/category/' + this.store_id.value,
        )
        .then((response) => {
          var data = response.data
          for (var i = 0; i < data.length; i++) {
            var json = {
              value: data[i].id,
              label: data[i].name,
            }
            a.push(json)
          }
          console.log(a)
          this.category = a

          if (response.data != null) {
            this.$q.loading.hide()
          }
        })
        .catch((e) => {
          var res = e.response
          this.$q.loading.hide()
          if (res.status == 401) {
            this.auth()
          } else {
            this.$e('Something Errors')
          }
        })
    },
    async stores() {
      await axios
        .get('http://127.0.0.1:8000/api/statistic/getstore')
        .then((response) => {
          var data = response.data
          console.log(response.data)
          for (var i = 0; i < data.length; i++) {
            var json = {
              value: data[i].id,
              label: data[i].name,
            }
            this.store.push(json)
          }

          if (response.data != null) {
            this.$q.loading.hide()
          }
        })
        .catch((e) => {
          var res = e.response
          this.$q.loading.hide()
          if (res.status == 401) {
            this.auth()
          } else {
            this.$e('Something Errors')
          }
        })
    },
    async pio() {},
    SendAddData() {
      console.log(this.AddData)
    },
    ShowAddModal() {
      this.AddModal = true
    },
    AddModalCancel() {
      this.AddData = {
        id: '',
        product_id: '',
        user_id: '',
        store_id: '',
        count: '',
        price: '',
      }
      this.AddModal = false
    },
    filterProduct(val, update) {
      if (val === '') {
        update(() => {
          this.optionsProduct = this.product

          // here you have access to "ref" which
          // is the Vue reference of the QSelect
        })
        return
      }

      update(() => {
        const needle = val.toLowerCase()

        this.optionsProduct = this.product.filter(
          (v) => v.toLowerCase().indexOf(needle) > -1,
        )
      })
    },
    filterStore(val, update) {
      if (val === '') {
        update(() => {
          this.optionsStore = this.store

          // here you have access to "ref" which
          // is the Vue reference of the QSelect
        })
        return
      }

      update(() => {
        const needle = val.toLowerCase()

        this.optionsStore = this.store.filter(
          (v) => v.toLowerCase().indexOf(needle) > -1,
        )
      })
    },
    filterCategory(val, update) {
      if (val === '') {
        update(() => {
          this.optionsCategory = this.category

          // here you have access to "ref" which
          // is the Vue reference of the QSelect
        })
        return
      }

      update(() => {
        const needle = val.toLowerCase()

        this.optionsCategory = this.category.filter(
          (v) => v.toLowerCase().indexOf(needle) > -1,
        )
      })
    },
    Static(row) {
      this.StaticModel = true
      console.log(val)
    },
    createValue(val, done) {
      console.log(done)
    },
  },
}
</script>
